<?php

class p_set_avatar extends cmsPlugin {

    public function __construct(){
        $this->info['plugin']      = 'p_set_avatar';
        $this->info['title']       = 'Аватар по умолчанию';
        $this->info['description'] = 'Устанавливает случайный аватар при регистрации';
        $this->info['author']      = 'Pasha';
        $this->info['version']     = '1.0';
        $this->events[]            = 'USER_REGISTER';
		parent::__construct();
    }

    public function execute($event='', $user=array()){

        if($event == 'USER_REGISTER' && empty($user['imageurl'])){
			$filename = $this->buildAvatar();
			$this->inDB->query("UPDATE cms_user_profiles SET imageurl = '{$filename}' WHERE user_id = '{$user['user_id']}' LIMIT 1");
        }

        return $user;

    }

	private function buildAvatar(){

		$filename = md5(time()) . '.jpg';
		$cfg      = $this->inCore->loadComponentConfig('users');
		$items    = array(
			'body' => rand(0, 5),
			'face' => rand(0, 7),
			'eyes' => rand(0, 7),
			'nose' => rand(0, 8),
			'hair' => rand(0, 11),
			'glas' => rand(0, 10)
		);

		$image    = imagecreatetruecolor($cfg['medw'], $cfg['medh']);
		$bg_color = imagecolorallocate($image, 255, 255, 255);
		imagefill($image, 0, 0, $bg_color);

		foreach($items as $item=>$num){
			$file = __DIR__ .'/items/'.$item.'_'.$num.'.png';
			if(file_exists($file)){
				$size = getimagesize($file);
				$png  = imagecreatefrompng($file);
				imagealphablending($png, true);
				imagesavealpha($png, true);
				imagecopyresampled($image, $png, 0, 0, 0, 0, $cfg['medw'], $cfg['medh'], $size[0], $size[1]);
				imagedestroy($png);
			}
		}

		imagejpeg($image, PATH.'/images/users/avatars/'.$filename, 100);
		imagedestroy($image);

		cmsCore::includeGraphics();
		img_resize(PATH.'/images/users/avatars/'.$filename, PATH.'/images/users/avatars/small/'.$filename, $cfg['smallw'], $cfg['smallw'], true, false);
		
		return $filename;
	
	}

}
